#include "main.h"
#include "i2c.h"

void i2c_init(void)
{
	TWBR = BUSFREQUENZ;            									   //TWBR ist Register um SCL Frequenz einzustellen. Formel, siehe Datenblatt
	TWSR &= ~((1<<TWPS0)|(1<<TWPS1));								   //Prescaler einstellen									
	DDRC=0x00;
	PORTC=0xFF;
}

void i2c_start(void)
{
	TWCR = (1<<TWINT) | (1<<TWSTA) | (1<<TWEN);						   //Interrupt Flag löschen, Start und Enable
	while (!( TWCR & (1<<TWINT)));									   //warten, bis Interrupt Flag wieder gesetzt wird	
}

void i2c_write(BYTE daten)
{
	TWDR = daten;								   						//Slave Adresse in TWDR schreiben
	TWCR = (1<<TWINT) | (1<<TWEN);                                     //Senden (durch Interrupt Flag löschen)
	while (!( TWCR & (1<<TWINT)));									   //Warten bis Interrupt Flag wieder gesetzt wird
}

BYTE i2c_read(BYTE slave_adresse)
{
	TWDR = slave_adresse | (1<<0);
	TWCR = (1<<TWINT) | (1<<TWEN);
	while (!( TWCR & (1<<TWINT)));
	
	return TWDR;
}

void i2c_stop(void)
{
	TWCR = (1<<TWINT) | (1<<TWEN) | (1<<TWSTO);
}
	







void led_an(void)
{
	DDRB=0xFF;
	PORTB=0x00;
}

void led_aus(void)
{
	DDRB=0xFF;
	PORTB=0xFF;
}


